local plantsPlanted = {}
local plantsGrowing = {}
local harvestField = {5355.9956054688,-5174.1142578125,29.500099182129}
local plantsObject = "prop_bush_med_02"

local function drawText(text, x, y, scale, r, g, b)
	SetTextFont(font)
	SetTextCentre(1)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextDropShadow(30, 5, 5, 5, 255)
	SetTextEntry("STRING")
	SetTextColour(r, g, b, 255)
	AddTextComponentString(text)
	DrawText(x, y)
end

local function DrawText3D(x,y,z, text, scl) 

    local onScreen,_x,_y=World3dToScreen2d(x,y,z)
    local px,py,pz=table.unpack(GetGameplayCamCoords())
    local dist = GetDistanceBetweenCoords(px,py,pz, x,y,z, 1)
 
    local scale = (1/dist)*scl
    local fov = (1/GetGameplayCamFov())*100
    local scale = scale*fov
   
    if onScreen then
        SetTextScale(0.0*scale, 1.1*scale)
        SetTextFont(0)
        SetTextProportional(1)
        SetTextColour(255, 255, 255, 255)
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x,_y)
    end
end

function tvRP.plantSeed()
	local coords = GetEntityCoords(PlayerPedId())
	if(GetDistanceBetweenCoords(coords.x, coords.y, coords.z, harvestField[1], harvestField[2], harvestField[3], true) < 30.0)then
		if(#plantsPlanted < 15)then
			local plantModel = GetHashKey(plantsObject)
			RequestModel(plantModel)
			while not HasModelLoaded(plantModel) do
			   Wait(1)
			end
			plantsGrowing[#plantsGrowing+1] = CreateObject(plantsObject, coords.x, coords.y, coords.z-2.0, false, false, true)
			plantsPlanted[#plantsPlanted+1] = {stage = 0, done = false}
			vRPserver.executePlanting({})
		else
			tvRP.notify("Ai plantat prea multe seminte!",2)
		end
	else
		tvRP.notify("Poti planta aceasta samanta doar pe un camp!",2)
	end
end

local sugepl = false

Citizen.CreateThread(function()
    while true do
		local timeTrf = 1000
        local pos = GetEntityCoords(PlayerPedId())
		if(GetDistanceBetweenCoords(pos.x,pos.y,pos.z, harvestField[1], harvestField[2], harvestField[3], true) < 25.0)then
			timeTrf = 0
			if(#plantsPlanted < 15)then
				DrawText3D(pos.x,pos.y,pos.z+1.20, "~HUD_COLOUR_NET_PLAYER13~[H]~w~ pentru a planta semintele", 0.5)
			else
				DrawText3D(pos.x,pos.y,pos.z+1.20, "~r~Ai plantat prea multe seminte", 0.5)
			end
			if(IsControlJustPressed(1, 74) and (#plantsPlanted < 15) and not sugepl)then
				local mama = 0
				for i, v in pairs(plantsPlanted) do
					local cordsplantaveche = GetEntityCoords(plantsGrowing[i])
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, cordsplantaveche.x, cordsplantaveche.y, cordsplantaveche.z, true) < 3.0)then
						mama = 1
						break
					end
				end
				if mama == 0 then
					FreezeEntityPosition(ped,true)
					tvRP.playAnim(false, {task="WORLD_HUMAN_GARDENER_PLANT"}, false)
					sugepl = true
					exports['progressbar']:Progress({
						name = "random_task",
						duration = 20000,
						label = "Plantezi seminte",
						useWhileDead = false,
						canCancel = false,
						controlDisables = {
							disableMovement = false,
							disableCarMovement = false,
							disableMouse = false,
							disableCombat = true,
						},
						animation = {},
						prop = {},
						propTwo = {}
					  }, function(cancelled)
						if not cancelled then
							FreezeEntityPosition(ped,false)
							tvRP.stopAnim(false)
							sugepl = false
							TriggerServerEvent('brx:planteaza')
						end
					end)
				else
					tvRP.notify("Este deja o planta aici!",2)
				end
	        end
		end
		Wait(timeTrf)
	end
end)
Citizen.CreateThread(function()
	while true do
		Citizen.Wait(60000)
		for i, v in pairs(plantsPlanted) do
			if(v.stage < 5) and (v.done == false)then
				local model = plantsObject
				local coords = GetEntityCoords(plantsGrowing[i])
				DeleteObject(plantsGrowing[i])
				plantsGrowing[i] = CreateObject(plantsObject, coords.x, coords.y, coords.z+0.005, false, false, true)
				v.stage = v.stage + 1
			else
				v.done = true
			end
		end
	end
end)
Citizen.CreateThread(function()
	while true do
		local timeTrf = 1000
		local coords = GetEntityCoords(PlayerPedId())
		for i, v in pairs(plantsPlanted) do
			timeTrf = 0
			local pCoords = GetEntityCoords(plantsGrowing[i])
			if(v.done)then
				if(GetDistanceBetweenCoords(coords.x, coords.y, coords.z, pCoords.x, pCoords.y, pCoords.z, true) < 5.0)then
					DrawText3D(pCoords.x, pCoords.y, pCoords.z+1.0, "~r~'E' ~HUD_COLOUR_NET_PLAYER13~pentru a culege planta", 0.75)
					if(IsControlJustReleased(1, 51))then
						DeleteObject(plantsGrowing[i])
						plantsGrowing[i] = nil
						plantsPlanted[i] = nil
						vRPserver.harvestDrugPlant({})
						Wait(200)
						break
					end
				end
			else
				if(GetDistanceBetweenCoords(coords.x, coords.y, coords.z, pCoords.x, pCoords.y, pCoords.z, true) < 5.0)then
					DrawText3D(pCoords.x, pCoords.y, pCoords.z+1.0, "~r~Planta este in crestere...", 0.75)
				end
			end
		end
		Wait(timeTrf)
	end
end)

local muiebalu = false

Citizen.CreateThread(function()
	while true do
        local ped = PlayerPedId()
        if #(GetEntityCoords(ped) - vector3(5144.18359375,-5115.8208007812,-1.3742656707764)) <= 5.0 then
            ticks = 1
            if muiebalu == false then
                DrawText3D(5144.18359375,-5115.8208007812,-1.3742656707764-0.15, "Proceseaza Marijuana", 1.0)
                DrawMarker(2,5144.18359375,-5115.8208007812,-1.3742656707764-0.5, 0, 0, 0, 0, 0, 0, 0.35, 0.35, 0.35, 253, 190, 34, 165, 0, 0, 0, 1)
                if #(GetEntityCoords(ped) - vector3(5144.18359375,-5115.8208007812,-1.3742656707764)) <= 3.0 then
                    drawText("~HUD_COLOUR_NET_PLAYER13~E~w~ , 7 Cannabis = 1 Marijuana", 0.5, 0.9, 0.4, 255, 255, 255)
                    if IsControlJustPressed(1,51) then
                        exports['zeus_minigames']:skill_circle({
                            style = 'default',
                            icon = 'fa-solid fa-crown',
                            area_size = 4,
                            speed = 0.03,
                        }, function(success)
                            if success == 'perfect' then
                                FreezeEntityPosition(ped,true)
                                muiebalu = true
                                tvRP.playAnim(false, {task="PROP_HUMAN_BUM_BIN"}, false)
                                exports['progressbar']:Progress({
                                    name = "random_task",
                                    duration = 25000,
                                    label = "Procesezi Marijuana",
                                    useWhileDead = false,
                                    canCancel = false,
                                    controlDisables = {
                                        disableMovement = false,
                                        disableCarMovement = false,
                                        disableMouse = false,
                                        disableCombat = true,
                                    },
                                    animation = {},
                                    prop = {},
                                    propTwo = {}
                                  }, function(cancelled)
                                    if not cancelled then
                                        FreezeEntityPosition(ped,false)
                                        tvRP.stopAnim(false)
                                        muiebalu = false
                                        vRPserver.famarijuana({})
                                    end
                                end)
                            end
                        end)
                    end
                end
            end
        end
        Citizen.Wait(ticks)
        ticks = 1000
    end
end)